Index: lemon/dfs.h
===================================================================
--- lemon/dfs.h	(revision 327)
+++ lemon/dfs.h	(revision 220)
@@ -1314,19 +1282,18 @@
     ///@{
     template <class T>
-    struct SetReachedMapTraits : public Traits {
+    struct DefReachedMapTraits : public Traits {
       typedef T ReachedMap;
       static ReachedMap *createReachedMap(const Digraph &digraph) {
-        LEMON_ASSERT(false, "ReachedMap is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
     };
     /// \brief \ref named-templ-param "Named parameter" for setting
-    /// ReachedMap type.
-    ///
-    /// \ref named-templ-param "Named parameter" for setting ReachedMap type.
+    /// ReachedMap type
+    ///
+    /// \ref named-templ-param "Named parameter" for setting ReachedMap type
     template <class T>
-    struct SetReachedMap : public DfsVisit< Digraph, Visitor,
-                                            SetReachedMapTraits<T> > {
-      typedef DfsVisit< Digraph, Visitor, SetReachedMapTraits<T> > Create;
+    struct DefReachedMap : public DfsVisit< Digraph, Visitor,
+                                            DefReachedMapTraits<T> > {
+      typedef DfsVisit< Digraph, Visitor, DefReachedMapTraits<T> > Create;
     };
     ///@}
@@ -1338,6 +1305,7 @@
     /// Constructor.
     ///
-    /// \param digraph The digraph the algorithm runs on.
-    /// \param visitor The visitor object of the algorithm.
+    /// \param digraph the digraph the algorithm will run on.
+    /// \param visitor The visitor of the algorithm.
+    ///
     DfsVisit(const Digraph& digraph, Visitor& visitor)
       : _digraph(&digraph), _visitor(&visitor),
@@ -1345,13 +1313,15 @@
 
     /// \brief Destructor.
+    ///
+    /// Destructor.
     ~DfsVisit() {
       if(local_reached) delete _reached;
     }
 
-    /// \brief Sets the map that indicates which nodes are reached.
-    ///
-    /// Sets the map that indicates which nodes are reached.
+    /// \brief Sets the map indicating if a node is reached.
+    ///
+    /// Sets the map indicating if a node is reached.
     /// If you don't use this function before calling \ref run(),
-    /// it will allocate one. The destructor deallocates this
+    /// it will allocate one. The destuctor deallocates this
     /// automatically allocated map, of course.
     /// \return <tt> (*this) </tt>
@@ -1366,21 +1336,19 @@
 
   public:
-
     /// \name Execution control
     /// The simplest way to execute the algorithm is to use
-    /// one of the member functions called \ref lemon::DfsVisit::run()
-    /// "run()".
+    /// one of the member functions called \c run(...).
     /// \n
-    /// If you need more control on the execution, first you must call
-    /// \ref lemon::DfsVisit::init() "init()", then you can add several
-    /// source nodes with \ref lemon::DfsVisit::addSource() "addSource()".
-    /// Finally \ref lemon::DfsVisit::start() "start()" will perform the
-    /// actual path computation.
+    /// If you need more control on the execution,
+    /// first you must call \ref init(), then you can adda source node
+    /// with \ref addSource().
+    /// Finally \ref start() will perform the actual path
+    /// computation.
 
     /// @{
-
     /// \brief Initializes the internal data structures.
     ///
     /// Initializes the internal data structures.
+    ///
     void init() {
       create_maps();
@@ -1392,16 +1360,8 @@
     }
 
-    ///Adds a new source node.
-
-    ///Adds a new source node to the set of nodes to be processed.
-    ///
-    ///\pre The stack must be empty. (Otherwise the algorithm gives
-    ///false results.)
-    ///
-    ///\warning Distances will be wrong (or at least strange) in case of
-    ///multiple sources.
-    void addSource(Node s)
-    {
-      LEMON_DEBUG(emptyQueue(), "The stack is not empty.");
+    /// \brief Adds a new source node.
+    ///
+    /// Adds a new source node to the set of nodes to be processed.
+    void addSource(Node s) {
       if(!(*_reached)[s]) {
           _reached->set(s,true);
@@ -1424,5 +1384,5 @@
     /// \return The processed arc.
     ///
-    /// \pre The stack must not be empty.
+    /// \pre The stack must not be empty!
     Arc processNextArc() {
       Arc e = _stack[_stack_head];
@@ -1458,19 +1418,19 @@
     /// \return The next arc to be processed or INVALID if the stack is
     /// empty.
-    Arc nextArc() const {
+    Arc nextArc() {
       return _stack_head >= 0 ? _stack[_stack_head] : INVALID;
     }
 
     /// \brief Returns \c false if there are nodes
-    /// to be processed.
+    /// to be processed in the queue
     ///
     /// Returns \c false if there are nodes
-    /// to be processed in the queue (stack).
-    bool emptyQueue() const { return _stack_head < 0; }
+    /// to be processed in the queue
+    bool emptyQueue() { return _stack_head < 0; }
 
     /// \brief Returns the number of the nodes to be processed.
     ///
-    /// Returns the number of the nodes to be processed in the queue (stack).
-    int queueSize() const { return _stack_head + 1; }
+    /// Returns the number of the nodes to be processed in the queue.
+    int queueSize() { return _stack_head + 1; }
 
     /// \brief Executes the algorithm.
@@ -1478,39 +1438,18 @@
     /// Executes the algorithm.
     ///
-    /// This method runs the %DFS algorithm from the root node
-    /// in order to compute the %DFS path to each node.
-    ///
-    /// The algorithm computes
-    /// - the %DFS tree,
-    /// - the distance of each node from the root in the %DFS tree.
-    ///
-    /// \pre init() must be called and a root node should be
-    /// added with addSource() before using this function.
-    ///
-    /// \note <tt>d.start()</tt> is just a shortcut of the following code.
-    /// \code
-    ///   while ( !d.emptyQueue() ) {
-    ///     d.processNextArc();
-    ///   }
-    /// \endcode
+    /// \pre init() must be called and at least one node should be added
+    /// with addSource() before using this function.
     void start() {
       while ( !emptyQueue() ) processNextArc();
     }
 
-    /// \brief Executes the algorithm until the given target node is reached.
-    ///
-    /// Executes the algorithm until the given target node is reached.
-    ///
-    /// This method runs the %DFS algorithm from the root node
-    /// in order to compute the DFS path to \c t.
-    ///
-    /// The algorithm computes
-    /// - the %DFS path to \c t,
-    /// - the distance of \c t from the root in the %DFS tree.
-    ///
-    /// \pre init() must be called and a root node should be added
+    /// \brief Executes the algorithm until \c dest is reached.
+    ///
+    /// Executes the algorithm until \c dest is reached.
+    ///
+    /// \pre init() must be called and at least one node should be added
     /// with addSource() before using this function.
-    void start(Node t) {
-      while ( !emptyQueue() && _digraph->target(_stack[_stack_head]) != t )
+    void start(Node dest) {
+      while ( !emptyQueue() && _digraph->target(_stack[_stack_head]) != dest )
         processNextArc();
     }
@@ -1520,35 +1459,26 @@
     /// Executes the algorithm until a condition is met.
     ///
-    /// This method runs the %DFS algorithm from the root node
-    /// until an arc \c a with <tt>am[a]</tt> true is found.
-    ///
-    /// \param am A \c bool (or convertible) arc map. The algorithm
-    /// will stop when it reaches an arc \c a with <tt>am[a]</tt> true.
-    ///
-    /// \return The reached arc \c a with <tt>am[a]</tt> true or
-    /// \c INVALID if no such arc was found.
-    ///
-    /// \pre init() must be called and a root node should be added
+    /// \pre init() must be called and at least one node should be added
     /// with addSource() before using this function.
     ///
-    /// \warning Contrary to \ref Bfs and \ref Dijkstra, \c am is an arc map,
+    /// \param em must be a bool (or convertible) arc map. The algorithm
+    /// will stop when it reaches an arc \c e with <tt>em[e]</tt> true.
+    ///
+    ///\return The reached arc \c e with <tt>em[e]</tt> true or
+    ///\c INVALID if no such arc was found.
+    ///
+    /// \warning Contrary to \ref Bfs and \ref Dijkstra, \c em is an arc map,
     /// not a node map.
-    template <typename AM>
-    Arc start(const AM &am) {
-      while ( !emptyQueue() && !am[_stack[_stack_head]] )
+    template <typename EM>
+    Arc start(const EM &em) {
+      while ( !emptyQueue() && !em[_stack[_stack_head]] )
         processNextArc();
       return emptyQueue() ? INVALID : _stack[_stack_head];
     }
 
-    /// \brief Runs the algorithm from the given source node.
-    ///
-    /// This method runs the %DFS algorithm from node \c s.
-    /// in order to compute the DFS path to each node.
-    ///
-    /// The algorithm computes
-    /// - the %DFS tree,
-    /// - the distance of each node from the root in the %DFS tree.
-    ///
-    /// \note <tt>d.run(s)</tt> is just a shortcut of the following code.
+    /// \brief Runs %DFSVisit algorithm from node \c s.
+    ///
+    /// This method runs the %DFS algorithm from a root node \c s.
+    /// \note d.run(s) is just a shortcut of the following code.
     ///\code
     ///   d.init();
@@ -1562,44 +1492,20 @@
     }
 
-    /// \brief Finds the %DFS path between \c s and \c t.
-
-    /// This method runs the %DFS algorithm from node \c s
-    /// in order to compute the DFS path to node \c t
-    /// (it stops searching when \c t is processed).
-    ///
-    /// \return \c true if \c t is reachable form \c s.
-    ///
-    /// \note Apart from the return value, <tt>d.run(s,t)</tt> is
-    /// just a shortcut of the following code.
+    /// \brief Runs %DFSVisit algorithm to visit all nodes in the digraph.
+
+    /// This method runs the %DFS algorithm in order to
+    /// compute the %DFS path to each node. The algorithm computes
+    /// - The %DFS tree.
+    /// - The distance of each node from the root in the %DFS tree.
+    ///
+    ///\note d.run() is just a shortcut of the following code.
     ///\code
-    ///   d.init();
-    ///   d.addSource(s);
-    ///   d.start(t);
-    ///\endcode
-    bool run(Node s,Node t) {
-      init();
-      addSource(s);
-      start(t);
-      return reached(t);
-    }
-
-    /// \brief Runs the algorithm to visit all nodes in the digraph.
-
-    /// This method runs the %DFS algorithm in order to
-    /// compute the %DFS path to each node.
-    ///
-    /// The algorithm computes
-    /// - the %DFS tree,
-    /// - the distance of each node from the root in the %DFS tree.
-    ///
-    /// \note <tt>d.run()</tt> is just a shortcut of the following code.
-    ///\code
-    ///   d.init();
-    ///   for (NodeIt n(digraph); n != INVALID; ++n) {
-    ///     if (!d.reached(n)) {
-    ///       d.addSource(n);
-    ///       d.start();
-    ///     }
-    ///   }
+    ///  d.init();
+    ///  for (NodeIt it(digraph); it != INVALID; ++it) {
+    ///    if (!d.reached(it)) {
+    ///      d.addSource(it);
+    ///      d.start();
+    ///    }
+    ///  }
     ///\endcode
     void run() {
@@ -1612,5 +1518,4 @@
       }
     }
-
     ///@}
 
@@ -1618,21 +1523,21 @@
     /// The result of the %DFS algorithm can be obtained using these
     /// functions.\n
-    /// Either \ref lemon::DfsVisit::run() "run()" or
-    /// \ref lemon::DfsVisit::start() "start()" must be called before
-    /// using them.
+    /// Before the use of these functions,
+    /// either run() or start() must be called.
     ///@{
-
-    /// \brief Checks if a node is reachable from the root(s).
+    /// \brief Checks if a node is reachable from the root.
     ///
     /// Returns \c true if \c v is reachable from the root(s).
+    /// \warning The source nodes are inditated as unreachable.
     /// \pre Either \ref run() or \ref start()
     /// must be called before using this function.
+    ///
     bool reached(Node v) { return (*_reached)[v]; }
-
     ///@}
-
   };
 
+
 } //END OF NAMESPACE LEMON
 
 #endif
+
